#include<bits/stdc++.h>
using namespace std;
long long vred[1000009],b[1000009],c[1000009],i,j,m,n,h,pret,zbir;
main()
{
	ios_base::sync_with_stdio(0);
	cin>>h>>n;
	for(i=0;i<n;i++)
	vred[i]=1;
	
	for(m=1;m<=h;m++)
	{
	for(i=0;i<n;i++)
	{
	cin>>b[i];
    c[i]=0;
	}
	
	zbir=0;
	pret=0;
	
	while(b[pret]==0)
	pret++;
	
	for(i=0;i<=pret;i++)
	zbir+=vred[i];

	c[pret]=zbir;
    zbir=0;
    
for(i=pret+1;i<n;i++)
{
	if(b[i]==1)
	{
	c[i]+=vred[i]+zbir/2;
	c[pret]+=zbir/2;
	
	if(zbir%2==1)
	{
	 if(m%2==1)
	c[pret]++;
	 else
    c[i]++;
    }
    
	pret=i;
	zbir=0;
    }
	else 
	zbir+=vred[i];
}

c[pret]+=zbir;

for(i=0;i<n;i++)
{
    vred[i]=c[i];
//cout<<vred[i]<<" ";
//cout<<endl;
}
	}
	
	for(i=0;i<n;i++)
	cout<<vred[i]<<" ";
	return 0;
}